// BitmapInfoView.cpp : implementation file
//

#include "stdafx.h"
#include "DDDemo.h"

#include "DDDemoDoc.h"
#include "BitmapInfoView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBitmapInfoView

IMPLEMENT_DYNCREATE(CBitmapInfoView, CEditView)

CBitmapInfoView::CBitmapInfoView()
{
}

CBitmapInfoView::~CBitmapInfoView()
{
}


BEGIN_MESSAGE_MAP(CBitmapInfoView, CEditView)
	//{{AFX_MSG_MAP(CBitmapInfoView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBitmapInfoView drawing

void CBitmapInfoView::OnDraw(CDC* /*pDC*/)
{
	//CDDDemoDoc* pDoc = GetDocument();
	// TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// CBitmapInfoView diagnostics

#ifdef _DEBUG
void CBitmapInfoView::AssertValid() const
{
	CEditView::AssertValid();
}

void CBitmapInfoView::Dump(CDumpContext& dc) const
{
	CEditView::Dump(dc);
}

CDDDemoDoc* CBitmapInfoView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDDDemoDoc)));
	return (CDDDemoDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
//

BOOL CBitmapInfoView::LoadInfo(LPCTSTR lpszPathName)
{
	CString csData;
	CString csTemp;
	LPBYTE pBuffer = NULL;
	DWORD dwFileLen = 0L;
	try
	{
		LPBYTE pDib   = NULL;
		LPBYTE pImage = NULL;
		DWORD  dwMaxImageSize = 0L;

		// Read file into temporary buffer
		if( !lpszPathName )
		{
			CDDDemoDoc* pDoc = GetDocument();
			ASSERT_VALID(pDoc);

			pDib   = pDoc->m_DibData.GetDibPtr();
			if( !pDib )
				return FALSE;
			pImage = pDoc->m_DibData.GetImagePtr();
			dwMaxImageSize = pDoc->m_DibData.GetMaxImageSize();
		}
		else
		{
			CFile cf(lpszPathName, CFile::modeRead);
			dwFileLen = cf.GetLength();
			pBuffer = new BYTE[dwFileLen];
			if( !pBuffer )
			{
				cf.Close();
				return FALSE;
			}
			cf.Read((void*)pBuffer, (UINT)dwFileLen);
			cf.Close();

			// Check if bitmap file header
			LPBITMAPFILEHEADER pbmfh = (LPBITMAPFILEHEADER)pBuffer;
			if( pbmfh->bfType != 0x4D42 )
			{
				delete [] pBuffer;
				return FALSE;
			}

			// Add file path to output string
			csTemp.Format(_T("FILE:%s\r\n"), lpszPathName);
			csData += csTemp;

			// Add file header to output string
			csTemp.Format(_T("\r\nBITMAPFILEHEADER:\r\n{\r\n"));
			csData += csTemp;
			csTemp.Format(_T(" bfType      = %X\r\n"), pbmfh->bfType);
			csData += csTemp;
			csTemp.Format(_T(" bfSize      = %u\r\n"), pbmfh->bfSize);
			csData += csTemp;
			csTemp.Format(_T(" bfReserved1 = %u\r\n"), pbmfh->bfReserved1);
			csData += csTemp;
			csTemp.Format(_T(" bfReserved2 = %u\r\n"), pbmfh->bfReserved2);
			csData += csTemp;
			csTemp.Format(_T(" bfOffBits   = %u\r\n"), pbmfh->bfOffBits);
			csData += csTemp;
			csTemp.Format(_T("};\r\n"));
			csData += csTemp;

			// Get ready to decifer dib data
			pDib = pBuffer + sizeof(BITMAPFILEHEADER);
			pImage = pDib + pbmfh->bfOffBits;
			dwMaxImageSize = dwFileLen - pbmfh->bfOffBits;
		}

		// Add bitmap header information to output string
		DWORD dwSize = *(LPDWORD)pDib;
		if( dwSize == sizeof(BITMAPCOREHEADER) )
		{
			LPBITMAPCOREHEADER pch = (LPBITMAPCOREHEADER)pDib;
			csTemp.Format(_T("\r\nBITMAPCOREHEADER:\r\n{\r\n"));
			csData += csTemp;
			csTemp.Format(_T(" bcSize     = %u\r\n"), pch->bcSize);
			csData += csTemp;
			csTemp.Format(_T(" bcWidth    = %u\r\n"), pch->bcWidth);
			csData += csTemp;
			csTemp.Format(_T(" bcHeight   = %u\r\n"), pch->bcHeight);
			csData += csTemp;
			csTemp.Format(_T(" bcPlanes   = %u\r\n"), pch->bcPlanes);
			csData += csTemp;
			csTemp.Format(_T(" bcBitCount = %u\r\n"), pch->bcBitCount);
			csData += csTemp;
			csTemp.Format(_T("};\r\n"));
			csData += csTemp;
		}
		else
		{
			LPCTSTR szCompression[] =
			{
				_T("BI_RGB"),
				_T("BI_RLE8"),
				_T("BI_RLE4"),
				_T("BI_BITFIELDS"),
				_T("BI_JPEG"),
				_T("BI_PNG")
			};

			LPBITMAPV5HEADER lpHeader = (LPBITMAPV5HEADER)pDib;
			if( dwSize == sizeof(BITMAPINFOHEADER) )
				csTemp.Format(_T("\r\nBITMAPINFOHEADER:\r\n{\r\n"));
			else if( dwSize == sizeof(BITMAPV4HEADER) )
				csTemp.Format(_T("\r\nBITMAPV4HEADER:\r\n{\r\n"));
			else if( dwSize == sizeof(BITMAPV5HEADER) )
				csTemp.Format(_T("\r\nBITMAPV5HEADER:\r\n{\r\n"));
			else
				csTemp.Format(_T("\r\nUNKNOWN:\r\n{\r\n"));

			csData += csTemp;

			if( dwSize >= sizeof(BITMAPINFOHEADER) )
			{
				csTemp.Format(_T(" Size          = %d\r\n"), lpHeader->bV5Size);
				csData += csTemp;
				csTemp.Format(_T(" Width         = %d\r\n"), lpHeader->bV5Width);
				csData += csTemp;
				csTemp.Format(_T(" Height        = %d\r\n"), lpHeader->bV5Height);
				csData += csTemp;
				csTemp.Format(_T(" Planes        = %u\r\n"), lpHeader->bV5Planes);
				csData += csTemp;
				csTemp.Format(_T(" BitCount      = %u\r\n"), lpHeader->bV5BitCount);
				csData += csTemp;
				csTemp.Format(_T(" Compression   = %s\r\n"),
					szCompression[lpHeader->bV5Compression%5]);
				csData += csTemp;
				csTemp.Format(_T(" SizeImage     = %u\r\n"), lpHeader->bV5SizeImage);
				csData += csTemp;
				csTemp.Format(_T(" XPelsPerMeter = %d\r\n"), lpHeader->bV5YPelsPerMeter);
				csData += csTemp;
				csTemp.Format(_T(" YPelsPerMeter = %d\r\n"), lpHeader->bV5XPelsPerMeter);
				csData += csTemp;
				csTemp.Format(_T(" ClrUsed       = %u\r\n"), lpHeader->bV5ClrUsed);
				csData += csTemp;
				csTemp.Format(_T(" ClrImportant  = %u\r\n"), lpHeader->bV5ClrImportant);
				csData += csTemp;
			}

			if( dwSize >= sizeof(BITMAPV4HEADER) )
			{
				#define CIE_DEC(V) ((((DWORD)(V)) >> 30) & 0x3)
				#define CIE_MAN(V) (((DWORD)(V)) & 0x3FFFFFFF)

				csTemp.Format(_T(" RedMask       = %u\r\n"), lpHeader->bV5RedMask);
				csData += csTemp;
				csTemp.Format(_T(" GreenMask     = %u\r\n"), lpHeader->bV5GreenMask);
				csData += csTemp;
				csTemp.Format(_T(" BlueMask      = %u\r\n"), lpHeader->bV5BlueMask);
				csData += csTemp;
				csTemp.Format(_T(" AlphaMask     = %u\r\n"), lpHeader->bV5AlphaMask);
				csData += csTemp;
				csTemp.Format(_T(" CSType        = %u\r\n"), lpHeader->bV5CSType);
				csData += csTemp;
				csTemp.Format(_T(" bV5Endpoints\r\n"));
				csData += csTemp;
				csTemp.Format(_T(" {\r\n"));
				csData += csTemp;
				csTemp.Format(_T("  ciexyzRed\r\n"));
				csData += csTemp;
				csTemp.Format(_T("  {\r\n"));
				csData += csTemp;
				csTemp.Format(_T("   ciexyzX     = %d.%d\r\n"),
					CIE_DEC(lpHeader->bV5Endpoints.ciexyzRed.ciexyzX),
					CIE_MAN(lpHeader->bV5Endpoints.ciexyzRed.ciexyzX));
				csData += csTemp;
				csTemp.Format(_T("   ciexyzY     = %d.%d\r\n"),
					CIE_DEC(lpHeader->bV5Endpoints.ciexyzRed.ciexyzY),
					CIE_MAN(lpHeader->bV5Endpoints.ciexyzRed.ciexyzY));
				csData += csTemp;
				csTemp.Format(_T("   ciexyzZ     = %d.%d\r\n"),
					CIE_DEC(lpHeader->bV5Endpoints.ciexyzRed.ciexyzZ),
					CIE_MAN(lpHeader->bV5Endpoints.ciexyzRed.ciexyzZ));
				csData += csTemp;
				csTemp.Format(_T("  };\r\n"));
				csData += csTemp;
				csTemp.Format(_T("  ciexyzGreen\r\n"));
				csData += csTemp;
				csTemp.Format(_T("  {\r\n"));
				csData += csTemp;
				csTemp.Format(_T("   ciexyzX     = %d.%d\r\n"),
					CIE_DEC(lpHeader->bV5Endpoints.ciexyzGreen.ciexyzX),
					CIE_MAN(lpHeader->bV5Endpoints.ciexyzGreen.ciexyzX));
				csData += csTemp;
				csTemp.Format(_T("   ciexyzY     = %d.%d\r\n"),
					CIE_DEC(lpHeader->bV5Endpoints.ciexyzGreen.ciexyzY),
					CIE_MAN(lpHeader->bV5Endpoints.ciexyzGreen.ciexyzY));
				csData += csTemp;
				csTemp.Format(_T("   ciexyzZ     = %d.%d\r\n"),
					CIE_DEC(lpHeader->bV5Endpoints.ciexyzGreen.ciexyzZ),
					CIE_MAN(lpHeader->bV5Endpoints.ciexyzGreen.ciexyzZ));
				csData += csTemp;
				csTemp.Format(_T("  };\r\n"));
				csData += csTemp;
				csTemp.Format(_T("  ciexyzBlue\r\n"));
				csData += csTemp;
				csTemp.Format(_T("  {\r\n"));
				csData += csTemp;
				csTemp.Format(_T("   ciexyzX     = %d.%d\r\n"),
					CIE_DEC(lpHeader->bV5Endpoints.ciexyzBlue.ciexyzX),
					CIE_MAN(lpHeader->bV5Endpoints.ciexyzBlue.ciexyzX));
				csData += csTemp;
				csTemp.Format(_T("   ciexyzY     = %d.%d\r\n"),
					CIE_DEC(lpHeader->bV5Endpoints.ciexyzBlue.ciexyzY),
					CIE_MAN(lpHeader->bV5Endpoints.ciexyzBlue.ciexyzY));
				csData += csTemp;
				csTemp.Format(_T("   ciexyzZ     = %d.%d\r\n"),
					CIE_DEC(lpHeader->bV5Endpoints.ciexyzBlue.ciexyzZ),
					CIE_MAN(lpHeader->bV5Endpoints.ciexyzBlue.ciexyzZ));
				csData += csTemp;
				csTemp.Format(_T("  };\r\n"));
				csData += csTemp;
				csTemp.Format(_T(" };\r\n"));
				csData += csTemp;
				csTemp.Format(_T(" GammaRed      = %u\r\n"), lpHeader->bV5GammaRed);
				csData += csTemp;
				csTemp.Format(_T(" GammaGreen    = %u\r\n"), lpHeader->bV5GammaGreen);
				csData += csTemp;
				csTemp.Format(_T(" GammaBlue     = %u\r\n"), lpHeader->bV5GammaBlue);
				csData += csTemp;
			}

			if( dwSize >= sizeof(BITMAPV5HEADER) )
			{
				csTemp.Format(_T(" Intent        = %u\r\n"), lpHeader->bV5Intent);
				csData += csTemp;
				csTemp.Format(_T(" ProfileData   = %u\r\n"), lpHeader->bV5ProfileData);
				csData += csTemp;
				csTemp.Format(_T(" ProfileSize   = %u\r\n"), lpHeader->bV5ProfileSize);
				csData += csTemp;
				csTemp.Format(_T(" Reserved      = %u\r\n"), lpHeader->bV5Reserved);
				csData += csTemp;
			}

			csTemp.Format(_T("};\r\n"));
			csData += csTemp;

			// Add bitfields to output string
			if( lpHeader->bV5Compression == BI_BITFIELDS )
			{
				LPDWORD pBitfields = LPDWORD(pDib + lpHeader->bV5Size);
				csTemp.Format(_T("\r\nBIT FIELDS\r\n{\r\n"
						 "   RED: %8.8X\r\n"
						 " GREEN: %8.8X\r\n"
						 "  BLUE: %8.8X\r\n};\r\n"),
					pBitfields[0], pBitfields[1], pBitfields[2]);
				csData += csTemp;
			}

			// Add color table to output string
			WORD wBpp = WORD(lpHeader->bV5BitCount * lpHeader->bV5Planes);
			if( wBpp <= 8 )
			{
				DWORD dwNumColors = 1 << wBpp;
				if( lpHeader->bV5ClrUsed )
					dwNumColors = lpHeader->bV5ClrUsed;

				DWORD dwOffset = lpHeader->bV5Size;
				if( lpHeader->bV5Compression == BI_BITFIELDS )
					dwOffset += 3 * sizeof(DWORD);

				LPRGBQUAD pColorTable = LPRGBQUAD(pDib + dwOffset);

				csTemp.Format(_T("\r\nCOLOR TABLE\r\n{\r\n"));
				csData += csTemp;
				for( DWORD i = 0; i < dwNumColors; ++i )
				{
					csTemp.Format(_T(" %3.3u) %2.2X, %2.2X, %2.2X\r\n"),
						i, pColorTable[i].rgbRed, 
						pColorTable[i].rgbGreen, pColorTable[i].rgbBlue);
					csData += csTemp;
				}
				csTemp.Format(_T("};\r\n"));
				csData += csTemp;
			}

			// Add image data to output string
			DWORD dwByteWidth = (((lpHeader->bV5Width * wBpp + 31) & ~31) >> 3);
			DWORD dwImageSize = dwByteWidth * abs(lpHeader->bV5Height);
			DWORD dwTempSize = dwImageSize;
			
			if( dwMaxImageSize < dwImageSize )
				dwImageSize = dwMaxImageSize;

			if( dwTempSize > 20000 )
				dwTempSize = 20000;

			DWORD i, n;
			csTemp.Format(_T("\r\nPIXEL BITS\r\n{\r\n"));
			csData += csTemp;
			for( i = 0; i < dwTempSize; )
			{
				for( n = 0; n < 4 && i < dwImageSize; ++n, i += 4 )
				{
					csTemp.Format(_T(" %2.2X %2.2X %2.2X %2.2X"),
						pImage[i  ], pImage[i+1],
						pImage[i+2], pImage[i+3]);
					csData += csTemp;
				}
				csData += _T("\r\n");
			}
			if( dwTempSize < dwImageSize )
			{
				csData += _T(" ..\r\n ..\r\n ..\r\n");
			}
			csTemp.Format(_T("};\r\n"));
			csData += csTemp;
		}
		SetWindowText(csData);
	}
	catch( CFileException* /*e*/ )
	{
		delete [] pBuffer;
		return FALSE;
	}
	delete [] pBuffer;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CBitmapInfoView message handlers

void CBitmapInfoView::OnInitialUpdate() 
{
	CEditView::OnInitialUpdate();
	
	// TODO: Add your specialized code here and/or call the base class
	
	//
	if( !m_Font.GetSafeHandle() )
	{
		LOGFONT lf;
		::ZeroMemory(&lf, sizeof(LOGFONT));
		lf.lfHeight = 16;
		_tcscpy(lf.lfFaceName, _T("Courier"));
		VERIFY(m_Font.CreateFontIndirect(&lf));
		SetFont(&m_Font);
	}

	// Read only
	GetEditCtrl().SetReadOnly();
}

void CBitmapInfoView::OnUpdate(CView* pSender, LPARAM lHint, CObject* /*pHint*/) 
{
	if( pSender != this )
	{
		CDDDemoDoc* pDoc = GetDocument();
		ASSERT_VALID(pDoc);
		
		const CString& csPath = pDoc->GetPathName();
		if( csPath.GetLength() > 0 )
		{
			CWaitCursor wait;
			GetEditCtrl().SetReadOnly(FALSE);
			if( lHint )
			{
				if( !LoadInfo(LPCTSTR(lHint)) )
					SetWindowText("");
			}
			else
			{
				if( !LoadInfo(csPath) )
				//if( !LoadInfo(NULL) )
					SetWindowText("");
			}
			GetEditCtrl().SetReadOnly();
		}
	}
}
